/* 
  1284.c
   1  2009-02-13  Matlib 
*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include <arguments.h>

struct Argument arguments [] =
{
  { 'd', "device", argument_string, ARGUMENT_F_ONCE | ARGUMENT_F_PAR, "/dev/lp" },
  { }
};
#define FILE_NAME (arguments [0].value)

int main (int argc, char **argv)
{
  int f, i;
  unsigned char buffer [10240];
  
  i = arguments_parse ("1284", "1", "", 
     "Reads IEEE1284 printer status of an USB device, default is /dev/lp.", 
     argc, argv, arguments);
  if (i != argc)
    arguments_error_freeform ("Invalid command line argument: %s.", 
       argv [i]);
  
  memset (buffer, 0, sizeof (buffer));
  f = open (FILE_NAME, O_RDONLY);
  if (f == -1)
  {
    perror (FILE_NAME);
    return EXIT_FAILURE;
  }
  if (ioctl (f, _IOC(_IOC_READ, 'P', 1, sizeof (buffer) - 1), buffer) != 0)
  {
    perror ("ioctl");
    return EXIT_FAILURE;
  }
  for (f = sizeof (buffer) - 1; (f > 0) && (buffer [f] == 0); f --);
  printf ("%u %u ", ((buffer [0] << 8) + buffer [1]) - 2, (++ f) - 2);
  for (i = 2; i < f; i ++)
    putchar (buffer [i]);
  return EXIT_SUCCESS;
}
